#pragma once

#include <RobotAPI/interface/armem/ReadingInterface.h>

#include <RobotAPI/libraries/armem/core/ice_conversions.h>
#include <RobotAPI/libraries/armem/memory/Memory.h>


namespace armarx::armem
{

    /**
     * @brief Helps sending data to a memory.
     */
    class MemoryReader
    {
    public:

        /**
         * @brief Construct a memory reader.
         * @param memory The memory proxy.
         */
        MemoryReader(ReadingInterfacePrx memory = nullptr);


        MemoryPtr getLatestSnapshots();
        MemoryPtr getAllData();

        data::MemoryPtr query(query::MemoryQueryPtr query);
        data::MemoryPtr query(query::MemoryQuerySeq queries);

        MemoryPtr queryToCpp(query::MemoryQueryPtr query);
        MemoryPtr queryToCpp(query::MemoryQuerySeq queries);


        operator bool() const
        {
            return bool(memory);
        }


    public:

        ReadingInterfacePrx memory;


    };

}
