#pragma once

#include <RobotAPI/interface/armem/memory.h>

#include "../core/ice_conversions.h"

#include "InternalCommit.h"
#include "Memory.h"


namespace armarx::armem
{

    void fromIce(const data::Commit& ice, InternalCommit& commit, Time timeArrived);
    void fromIce(const data::EntityUpdate& ice, InternalEntityUpdate& update, Time timeArrived);


    void toIce(data::EntityInstanceMetadata& ice, const EntityInstanceMetadata& metadata);
    void fromIce(const data::EntityInstanceMetadata& ice, EntityInstanceMetadata& metadata);

    void toIce(data::EntityInstance& ice, const EntityInstance& data);
    void fromIce(const data::EntityInstance& ice, EntityInstance& data);


    void toIce(data::EntitySnapshot& ice, const EntitySnapshot& snapshot);
    void fromIce(const data::EntitySnapshot& ice, EntitySnapshot& snapshot);

    void toIce(data::Entity& ice, const Entity& entity);
    void fromIce(const data::Entity& ice, Entity& entity);


    void toIce(data::ProviderSegment& ice, const ProviderSegment& providerSegment);
    void fromIce(const data::ProviderSegment& ice, ProviderSegment& providerSegment);

    void toIce(data::CoreSegment& ice, const CoreSegment& coreSegment);
    void fromIce(const data::CoreSegment& ice, CoreSegment& coreSegment);

    void toIce(data::Memory& ice, const Memory& memory);
    void fromIce(const data::Memory& ice, Memory& memory);


    namespace detail
    {
        void toIceItem(data::detail::MemoryItem& ice, const MemoryItem& item);
        void fromIceItem(const data::detail::MemoryItem& ice, MemoryItem& item);
    }

}
